#!/usr/bin/php-cgi -q
<?php

require_once(dirname(__FILE__).'/../lib/base-lib.inc');

function email( $toaddr='', $subject='', $msg='') {
    $cfg = array_get_from();
    $res = false;
    $ext_cmd = '';
    if ( !empty($cfg['MAIL']['SMTP_HOST']) && !empty($cfg['MAIL']['FROM']) && !empty( $toaddr) && !empty($msg)) {
	$url = "smtp";
	if (!empty($cfg['MAIL']['SMTP_SSL'])) {
	    $url .= "s";
	    $ext_cmd = ' --insecure';
	}
	$url .= "://".$cfg['MAIL']['SMTP_HOST'];
	if (!empty($cfg['MAIL']['SMTP_PORT']) && ($cfg['MAIL']['SMTP_PORT'] != 25))
	    $url .= ':'.$cfg['MAIL']['SMTP_PORT'];
	$ext_cmd .= " --url '".$url."'";
	if (!empty($cfg['MAIL']['SMTP_USERNAME'])) {
	    $ext_cmd .= " --user '".$cfg['MAIL']['SMTP_USERNAME'];
	    if (!empty($cfg['MAIL']['SMTP_PASSWORD']))
		$ext_cmd .= ":".$cfg['MAIL']['SMTP_PASSWORD'];
	    $ext_cmd .= "'";
	}
	$txt = "From: ".$cfg['MAIL']['FROM']."
To: ".$toaddr."
Subject: ".$subject."
MIME-Version: 1.0
Content-Type: text/plain
Date: ".strftime("%a, %d %b %Y %H:%M:%S %Z")."

".str_replace( '\n', chr(13).chr(10), $msg);
	$fname = get_tmp_file();
	file_put_contents( $fname, $txt);
	$ext_cmd .= " --mail-from '".$cfg['MAIL']['FROM']."' --mail-rcpt '".$toaddr."' --upload-file ".$fname;
	$res = (mwexec('curl', '--connect-timeout 30 --retry 1 '.$ext_cmd) == 0);
	unlink($fname);
    }
    return $res;
}

if ($argc < 3)
    exit(0);

email($argv[1], $argv[2], $argv[3]);
?>
