
DROP INDEX IF EXISTS sk_objects_idx_nickname CASCADE;
CREATE INDEX sk_objects_idx_nickname ON sk_objects (nickname) WHERE mode='P';

DROP INDEX IF EXISTS sk_providers_idx_key CASCADE;
CREATE INDEX sk_providers_idx_key ON sk_providers (key);

DROP INDEX IF EXISTS sk_service_idx_mix CASCADE;
CREATE INDEX sk_service_idx_mix ON sk_service (title);

DROP INDEX IF EXISTS sk_service_set_idx_mix CASCADE;
CREATE INDEX sk_service_set_idx_mix ON sk_service_set (service_id, provider_id);

DROP INDEX IF EXISTS sk_bank_info_idx CASCADE;
CREATE INDEX sk_bank_info_idx ON sk_bank_info (obj_id);

DROP INDEX IF EXISTS sk_currency_rate_idx_mix CASCADE;
CREATE INDEX sk_currency_rate_idx_mix ON sk_currency_rate (currency_id, rate_date);
