
DROP INDEX IF EXISTS sk_objects_idx_nickname;
CREATE INDEX sk_objects_idx_nickname ON sk_objects (substr(nickname,0,16)) WHERE mode='P';

DROP INDEX IF EXISTS sk_providers_idx_key;
CREATE INDEX sk_providers_idx_key ON sk_providers (substr(key,0,32));

DROP INDEX IF EXISTS sk_service_idx_mix;
CREATE INDEX sk_service_idx_mix ON sk_service (substr(title,0,64));

DROP INDEX IF EXISTS sk_bank_info_idx;
CREATE INDEX sk_bank_info_idx ON sk_bank_info (obj_id);

DROP INDEX IF EXISTS sk_service_set_idx_mix;
CREATE INDEX sk_service_set_idx_mix ON sk_service_set (service_id, provider_id);

DROP INDEX IF EXISTS sk_currency_rate_idx_mix;
CREATE INDEX sk_currency_rate_idx_mix ON sk_currency_rate (currency_id, rate_date);
