<?php
 class ProvidersDB extends ADO { var $className = 'Providers'; public function __construct( $app, $dburi, $debug=false, $tmode=true, $dformat='') { $this->owner = $app; if ( !empty($dburi)) $this->dburi = $dburi; return parent::__construct( $this->dburi, $debug, $tmode, $dformat); } public function get_records($lines_per_page, $page=0) { $res = $this->GetAll("SELECT count(*) FROM sk_providers WHERE role='P'"); if ( $page >= 0) { $low = $page*$lines_per_page; $high = $lines_per_page; $allRecs = $this->GetAll("SELECT sk_providers.provider_id, sk_providers.title, sk_providers.obj_id, sk_providers.exec_person, sk_providers.fin_person, sk_providers.adm_person, sk_providers.tech_person, sk_providers.resp_person, sk_providers.key, active  FROM sk_providers WHERE role='P' LIMIT ".$high." OFFSET ".$low); } else $allRecs = $this->GetAll("SELECT sk_providers.provider_id, sk_providers.title, sk_providers.obj_id, sk_providers.exec_person, sk_providers.fin_person, sk_providers.adm_person, sk_providers.tech_person, sk_providers.resp_person, sk_providers.key, active  FROM sk_providers WHERE role='P'"); return array($res[0][0], $allRecs); } public function insert_from_globals() { $i = 0; $key = ''; srand(); do { $key = uniq_gen(10); if (!$this->GetAll("SELECT key FROM sk_providers WHERE key='".$key."'")) break; $i ++; } while ($i < 10); if (($i == 10) || empty($key)) return false; $query = " INSERT INTO sk_providers (role, active, title, obj_id, c_sum, c_percent, sub_sum, sub_percent,
exec_person, fin_person, adm_person, tech_person, resp_person, add_date, last_date, comment, key) VALUES ('P', '". $GLOBALS['active']."','". $GLOBALS['title']."','". $GLOBALS['obj_id']."','". $GLOBALS['c_sum']."','". $GLOBALS['c_percent']."','". $GLOBALS['sub_sum']."','". $GLOBALS['sub_percent']."','". $GLOBALS['exec_person']."','". $GLOBALS['fin_person']."','". $GLOBALS['adm_person']."','". $GLOBALS['tech_person']."','". $GLOBALS['SSXID']."','". $this->owner->now()."','". $this->owner->now()."','". $GLOBALS['desc']."', '".$key."')"; $this->BeginTrans(); if ( $this->Execute( $query)) { $this->CommitTrans(); $this->owner->log(CMMN_INFO, $_SERVER['REMOTE_ADDR'], $_SERVER['PHP_SELF'], $GLOBALS['USER'], '', sprintf( STR_PROV_ADDED, $GLOBALS['title'])); return true; } else { $this->RollbackTrans(); $this->owner->log(CMMN_ERROR, $_SERVER['REMOTE_ADDR'], $_SERVER['PHP_SELF'], $GLOBALS['USER'], '', sprintf( STR_PROV_ADDED_ERR, $GLOBALS['title'])); } return false; } public function delete_from_globals() { if ( isset($GLOBALS['id'])) { $a = $this->GetAll("SELECT sk_objects.nickname FROM sk_objects,sk_operators WHERE sk_objects.obj_id=sk_operators.person_id AND sk_operators.operator_id='".$GLOBALS['id']."'"); $this->BeginTrans(); if ( $this->Execute("DELETE FROM sk_providers WHERE role='P' AND provider_id='".$GLOBALS['id']."'")) { $this->CommitTrans(); $this->owner->log(CMMN_INFO, $_SERVER['REMOTE_ADDR'], $_SERVER['PHP_SELF'], $GLOBALS['USER'], '', sprintf( STR_PROV_DELETED, $GLOBALS['id'])); lpd_library('user-lib.inc'); for ($i = 0; $i < count($a); $i++) { mwexec('/opt/stasoft/bin/revokecrt.sh', 'openvpn people-'.$a[$i][0]); if ( !empty($a[$i][0])) { user_del(sha1($a[$i][0])); user_del($a[$i][0]); exec_event_exec('rm -rf /home/pool/'.$prefix.$a[$i][0]); } } return true; } else { $this->RollbackTrans(); $this->owner->log(CMMN_ERROR, $_SERVER['REMOTE_ADDR'], $_SERVER['PHP_SELF'], $GLOBALS['USER'], '', sprintf( STR_PROV_DELETED_ERR, $GLOBALS['id'])); } } return false; } public function modify_from_globals() { $query = " UPDATE sk_providers SET 
			active='".$GLOBALS['active']."',
			title='".$GLOBALS['title']."',
			comment='".$GLOBALS['desc']."',
			obj_id='".$GLOBALS['obj_id']."',
			exec_person='".$GLOBALS['exec_person']."',
			fin_person='".$GLOBALS['fin_person']."',
			adm_person='".$GLOBALS['adm_person']."',
			tech_person='".$GLOBALS['tech_person']."',
			c_sum='".$GLOBALS['c_sum']."',
			c_percent='".$GLOBALS['c_percent']."',
			sub_sum='".$GLOBALS['sub_sum']."',
			sub_percent='".$GLOBALS['sub_percent']."',
			resp_person='".$GLOBALS['SSXID']."',
			last_date='".$this->owner->now()."'
 WHERE role='P' AND provider_id='".$GLOBALS['id']."'"; $this->BeginTrans(); if ( $this->Execute( $query)) { $this->CommitTrans(); $this->owner->log(CMMN_INFO, $_SERVER['REMOTE_ADDR'], $_SERVER['PHP_SELF'], $GLOBALS['USER'], '', sprintf( STR_PROV_EDITED, $GLOBALS['title'])); return true; } else { $this->RollbackTrans(); $this->owner->log(CMMN_ERROR, $_SERVER['REMOTE_ADDR'], $_SERVER['PHP_SELF'], $GLOBALS['USER'], '', sprintf( STR_PROV_EDITED_ERR, $GLOBALS['title'])); } return false; } public function get_record( $obj) { if ( ($a = $this->GetAll(sprintf("SELECT * FROM sk_providers WHERE provider_id='%s'", $obj)))) return $a[0]; else return array(); } } ?>
