7#!/usr/bin/php-cgi
<?php

error_reporting(E_ALL);

require_once(dirname(__FILE__).'/../../../lib/www-lib.inc');

class hotspot extends Dispatcher 
{
    var $uamsecret = 'uamsecret';
    var $loginpath;
    var $userpassword = 0;
    var $username = '';
    var $password = '';
    var $button = '';
    var $logout = '';
    var $challenge = '';
    var $prelogin = '';
    var $res = 'notyet';
    var $uamip = '10.1.0.1';
    var $uamport = 3990;
    var $userurl = '';
    var $timeleft = 0;
    var $redirurl = '';
    var $userurldecode = '';
    var $redirurldecode = '';
    var $uamserver = '';
    var $message = '';
    var $nasid = array();
    var $provider = 1;
    var $logo = '';
    var $a = array();
    var $subpath = '';
    var $do_redirect_because_promo_is_ended = false;
    var $show_error_message = false;

    public function __construct() {
	parent::__construct(array('appname'=>'hotspot', 'menu'=>'emp_menu', 'ui'=>'spectre'));
	if ( !isset($GLOBALS['LANGUAGE']))
	    $GLOBALS['LANGUAGE'] = $this->config['LANGUAGE'];
	$this->load_string_resource('hotspot');
	if (isset($this->config['x']['cp']['link']))
	    $this->uamserver = $this->config['x']['cp']['link'];
	$this->message = STR_HS_TITLE;
	if ( isset( $this->config['x']['cp']['uam_secret']))
	    $this->uamsecret = $this->config['x']['cp']['uam_secret'];
	if ( isset( $this->config['x']['cp']['uam_port']))
	    $this->uamport = $this->config['x']['cp']['uam_port'];
	if (isset($_POST['UserName']))	$this->username = $_POST['UserName'];
	if (isset($_REQUEST['id']))	$this->username = $_REQUEST['id'];
	if (isset($_REQUEST['password']))	$this->password = $_REQUEST['password'];
	if (isset($_POST['button']))	$this->button = $_POST['button'];
	if (isset($_POST['logout']))	$this->logout = $_POST['logout'];
	if (isset($_POST['prelogin']))	$this->prelogin = $_POST['prelogin'];
	if (isset($_REQUEST['challenge']))	$this->challenge = $_REQUEST['challenge'];
	if (isset($_REQUEST['res']))	$this->res = $_REQUEST['res'];
	if (isset($_REQUEST['uamip']))	$this->uamip = $_REQUEST['uamip'];
	if (isset($_REQUEST['addr']))	$this->uamip = $_REQUEST['addr'];
	if (isset($_REQUEST['uamport']))	$this->uamport = $_REQUEST['uamport'];
	if (isset($_REQUEST['userurl']))	$this->userurl = $_REQUEST['userurl'];
	if (isset($_REQUEST['timeleft']))	$this->timeleft = $_REQUEST['timeleft'];
	if (isset($_REQUEST['redirurl']))	$this->redirurl = $_REQUEST['redirurl'];
	if (isset($_REQUEST['redirect']))	$this->userurl = $_REQUEST['redirect'];
	if (isset($_REQUEST['uamsecret']))	$this->uamsecret = $_REQUEST['uamsecret'];
	if (isset($_REQUEST['nasid']))	$this->nasid = explode(' ', urldecode($_REQUEST['nasid']));
	if (isset($_GET['reply']))	$this->reply = $_GET['reply'];
	$this->redirurldecode = $this->redirurl;
	if (count($this->nasid) > 1) {
	    if (($a = $this->db->GetAll("SELECT sk_providers.provider_id FROM sk_providers, sk_equipment WHERE sk_providers.provider_id=sk_equipment.provider_id AND sk_equipment.title='".$this->nasid[0]."' AND sk_equipment.hw_address='".$this->nasid[1]."'")))
		$this->provider = $a[0][0];
		if ($this->provider < 1)
		    $this->provider = 1;
	}
	if (isset($this->config['x']['services']['cp'][0]) && is_array($this->config['x']['services']['cp'][0]))
	    $this->a = $this->config['x']['services']['cp'][0];
	else if (isset($this->config['x']['services']['cp']) && is_array($this->config['x']['services']['cp']))
	    $this->a = $this->config['x']['services']['cp'];
	if (($a = $this->db->get_value('hotspot_config', $this->provider))) {
	    $a = json_decode($a, true);
	    if (isset($a['cp'][0]))
		$this->a = array_join($this->a, $a['cp'][0]);
	    else if (isset($a['cp']))
		$this->a = array_join($this->a, $a['cp']);
	}
	if ( !empty( $this->a['landing_page']))
	    $this->userurl = $this->a['landing_page'];
	if ( !empty( $this->a['logo']))
	    $this->logo = $this->a['logo'];
	if ( !empty( $this->a['message']))
	    $this->message = $this->a['message'];
	if ( !empty( $this->a['promo'])) {
	    if (($a = $this->db->GetAll("SELECT password FROM sk_users WHERE username='PROMO_".(empty($this->config['BILLING']['ONE'])?$this->provider:1)."'"))) {
		$this->password = $a[0][0];
		$this->username = 'PROMO_'.(empty($this->config['BILLING']['ONE'])?$this->provider:1);
	    }
	}
	if ( !empty( $this->a['promo_by_mac'])) {
	    $mac = '';
	    $mac_gid = 0;
	    if (isset($_REQUEST['mac']))	$mac = $_REQUEST['mac'];
	    if ( isset( $this->a['promo_mac_gid']))	$mac_gid = $this->a['promo_mac_gid'];
	    if ( !empty($mac) && !empty($mac_gid)) {
		if (($b = $this->db->GetAll("SELECT total_time_limit, provider_id FROM sk_packets WHERE blocked=0 AND gid='".$mac_gid."'"))) {
		    if (($b[0][1] == $this->provider) && ($b[0][0] > 0)) {
			if (($a = $this->db->GetAll("SELECT password, total_time, total_time_limit, blocked FROM sk_users WHERE username='".$mac."' gid='".$mac_gid."'"))) {
			    $time_limit = ($a[0][2] != 0) ? $a[0][2] : $b[0][1];
			    if (($a[0][1] < $time_limit) && empty($a[0][3])) {
				$this->password = $a[0][0];
				$this->username = $mac;
			    } else $this->do_redirect_because_promo_is_ended = true;
			} else {
			    // Create new account
			    $db = $this->owner->load_db_resource('WebRAD');
			    if ( is_object($db)) {
				$this->password = uniq_gen();
				$this->username = $mac;
				if ( !$db->insert_user( $mac_gid, $mac, $this->password)) {
				    $this->password = '';
				    $this->username = '';
				    $this->show_error_message = true;
				}
			    } else $this->show_error_message = true;
			}
		    } else $this->show_error_message = true;
		} else $this->show_error_message = true;
	    }
	}
	$this->subpath = $this->provider.'/';
	if ( !file_exists('/opt/stasoft/www/views/hotspot/'.$this->subpath.'.###'))
	    $this->subpath = '';
	$this->userurldecode = $this->userurl;
    }

    private function do_login() {
	if ( !empty($this->button)) {
	    $hexchal = pack ("H32", $this->challenge);
	    if (!empty($this->uamsecret)) {
		$newchal = pack("H*", md5($hexchal . $this->uamsecret));
	    } else {
		$newchal = $hexchal;
	    }
	    $this->response = md5("\0" . $this->password . $newchal);
	    $newpwd = pack("a32", $this->password);
	    $pappassword = implode ("", unpack("H32", ($newpwd ^ $newchal)));
	    if (!empty($this->uamsecret) && ($this->userpassword>0)) {
		$refresh_var = "<meta http-equiv=\"refresh\" content=\"0;url=http://$this->uamip:$this->uamport/logon?username=$this->username&password=$pappassword\">";
	    } else {
		$refresh_var = "<meta http-equiv=\"refresh\" content=\"0;url=http://$this->uamip:$this->uamport/logon?username=$this->username&response=$this->response&userurl=$this->userurl\">";
	    }
	    $this->draw_simple_header( $refresh_var, STR_HS_LOGGING.'&nbsp;'.STR_HS_PLEASEWAIT);
	    $this->draw_simple_footer( true);
	    return true;
	}
	return false;
    }

    private function draw_simple_footer( $result=false) {
	$t = $this->load_template_resource(array('hForm'=>$this->subpath.'footerl'), TO_FOOTER);
	if ( $result) {
	    if (!empty($this->uamsecret) && ($this->userpassword>0)) {
		$t->set_var( 'APP_RESULT_CODE', "<LoginResultsURL>http://$this->uamip:$this->uamport/logon?username=$this->username&password=$pappassword</LoginResultsURL>");
	    } else {
		$t->set_var( 'APP_RESULT_CODE', "<LoginResultsURL>http://$this->uamip:$this->uamport/logon?username=$this->username&response=$this->response&userurl=$this->userurl</LoginResultsURL>");
	    }
	} else
	    $t->set_var( 'APP_RESULT_CODE', "");
	$t->set_var('APP_COPYRIGHT', $this->config['COPYRIGHT']);
	$t->set_var('APP_USER', $this->get_user());
	$t->set_var('LS_PATH', $this->get_ls_path());
	$t->pparse('out', 'hForm');
	$GLOBALS['FOOTER_GENERATED'] = 1;
    }
        
    private function draw_simple_header( $refresh_var='') {
	$t = $this->load_template_resource(array('hForm'=>$this->subpath.'headerl'), TO_HEADER);
	$t->set_block('hForm', 'logo', 'hLogo');
	$t->set_var('hLogo', '');
	$t->set_var('LS_PATH', $this->get_ls_path());
	$t->set_var('APP_REFRESH', $refresh_var);
	$t->set_var('PAGE_TITLE', $this->message);
	if (!empty($this->logo)) {
	    if (!empty($this->uamserver))
		$t->set_var('HOTSPOT_MAIN_SITE', $this->uamserver);
	    else
		$t->set_var('HOTSPOT_MAIN_SITE', '');
	    $t->set_var('HOTSPOT_LOGO', $this->logo);
	    $t->parse('hLogo', 'logo');
	}
	$t->set_var('APP_CHARSET', $this->config['CHARSET']);
	$t->set_var('APP_LANGUAGE', $GLOBALS['LANGUAGE']);
	$t->pparse('out', 'hForm');
	$GLOBALS['HEADER_GENERATED'] = 1;
	$GLOBALS['BBAR_GENERATED'] = 1;
    }
    
    private function do_error() {
	$this->draw_simple_header();
	$this->draw_simple_footer(false);
	$tmpl = $this->load_template_resource(array('hForm'=>'error'));
	$tmpl->set_var('LS_PATH', $this->get_ls_path());
	$tmpl->set_var('TXT_TITLE', STR_CMMN_ERROR);
	$tmpl->set_var('TXT_MESSAGE', STR_CMMN_PERMISSIONDENIED);
	$tmpl->pparse('out', 'hForm');
    }

    private function draw_body($msg='') {
	$tmpl = $this->load_template_resource(array('hForm'=>$this->subpath.'body'));
	$tmpl->set_var('TXT_MESSAGE', $msg);
	$tmpl->set_var('TXT_OBJ', '');
	if (!empty($this->a['embed_page']))
	    $tmpl->set_var('TXT_OBJ', '<object id="wembed" data="'.$this->a['embed_page'].'">&nbsp;</object>');
	$tmpl->pparse('out', 'hForm');
    }
    
    private function draw_login_form($msg='') {
	if (empty($this->password) || empty($this->username)) {
	    $t = $this->load_template_resource(array('hForm'=>$this->subpath.'login_us2'));
	    $t->set_var('TXT_RULES', STR_HS_LOGIN_RULES);
	    $t->set_var('TXT_USERNAME', STR_APP_USERNAME);
	    $t->set_var('TXT_PASSWORD', STR_APP_PASSWORD);
	    if (empty($this->username))
		$t->set_var('VAL_USERNAME', '');
	    else
		$t->set_var('VAL_USERNAME', $this->username);
	    $t->set_var( 'HIDDEN_VAR', "<input type=\"hidden\" name=\"challenge\" value=\"$this->challenge\" />
<input type=\"hidden\" name=\"uamip\" value=\"$this->uamip\" />
<input type=\"hidden\" name=\"uamport\" value=\"$this->uamport\" />
<input type=\"hidden\" name=\"uamsecret\" value=\"$this->uamsecret\" />
<input type=\"hidden\" name=\"userurl\" value=\"$this->userurl\" />");
	    $t->set_var('TXT_ACTION', STR_APP_LOGIN);
	    $t->set_var('TXT_TITLE', STR_APP_LOGIN_WELCOME);
	    $gl = $this->load_object_resource('core.redirect');
	    if ( is_object($gl)) {
		$GLOBALS['appname'] = urlencode($this->uamserver);
		$GLOBALS['provider_id'] = (empty($this->config['BILLING']['ONE'])?$this->provider:1);
		$GLOBALS['addr'] = $this->uamip;
		$GLOBALS['redirect'] = $this->userurl;
		$GLOBALS['challenge'] = $this->challenge;
		$this->pan_menu = $gl->get_links();
	    }
	} else {
	    $t = $this->load_template_resource(array('hForm'=>$this->subpath.'login_usf'));
	    $t->set_var('TXT_RULES', STR_HS_AUTHORIZED_RULES);
	    $t->set_var( 'HIDDEN_VAR', "<input type=\"hidden\" name=\"challenge\" value=\"$this->challenge\" />
<input type=\"hidden\" name=\"UserName\" value=\"$this->username\" />
<input type=\"hidden\" name=\"password\" value=\"$this->password\" />
<input type=\"hidden\" name=\"uamip\" value=\"$this->uamip\" />
<input type=\"hidden\" name=\"uamport\" value=\"$this->uamport\" />
<input type=\"hidden\" name=\"uamsecret\" value=\"$this->uamsecret\" />
<input type=\"hidden\" name=\"userurl\" value=\"$this->userurl\" />");
	    $t->set_var('TXT_ACTION', STR_HS_PRESET_LOGIN);
	    $t->set_var('TXT_TITLE', $this->message);
	}
	$t->set_var('TXT_MESSAGE', $msg);
	$t->set_var('LS_PATH', $this->get_ls_path());
	$t->set_var('TXT_UAMIP', $this->uamip);
	$t->set_var('TXT_UAMPORT', $this->uamport);
	$t->set_var('TXT_LOGINPATH', $this->uamserver);
	$t->set_var('VAL_FORMACTION', $this->uamserver);
	$t->set_block('hForm', 'ulink', 'hUlink');
	$t->set_var('TXT_REMIND', STR_HOTSPOT_REMIND);
	$t->set_var('TXT_CABINET', STR_HOTSPOT_CAB);
	$t->set_var('hUlink', '');
	array_push($this->pan_menu,array('/app/user/auth/','bbar/wizard.png',STR_HOTSPOT_REMIND,1));
	array_push($this->pan_menu,array('/app/suite/user/','bbar/home.png',STR_HOTSPOT_CAB,1));
//	for ($i = 0; $i < count($this->pan_menu); $i++) {
//	    $t->set_var('VAL_USERLINK', '<a href="'.GetMenuLink($this->pan_menu[$i][0]).'" target="_blank" >'.GetImage($this->pan_menu[$i][1]).$this->pan_menu[$i][2]."</a>");
//	    $t->parse('hUlink', 'ulink', true);
//	}
	$GLOBALS['draw_user_bbar'] = 1;
	$t->set_var('APP_LINKS', $this->print_bbar());
	$t->pparse('out', 'hForm');
    }
        
    private function draw_header($result=0) {
	$t = $this->load_template_resource(array('hForm'=>$this->subpath.'header'), TO_HEADER);
	$t->set_block('hForm', 'logo', 'hLogo');
	$t->set_var('hLogo', '');
	$t->set_var('LS_PATH', $this->get_ls_path());
//	$t->set_var('TXT_MESSAGE', $msg);
	$t->set_var('TXT_LOGINPATH', $this->uamserver);
	$t->set_var('TXT_UAMIP', $this->uamip);
	$t->set_var('TXT_UAMPORT', $this->uamport);
	$t->set_var('TXT_USERURL', $this->userurl);
	$t->set_var('TXT_REDIRURL', $this->redirurl);
	$t->set_var('TXT_TIMELEFT', $this->timeleft);
	$t->set_var('TXT_REDIRURLDECODE', $this->redirurldecode);
	$t->set_var('TXT_USERURLDECODE', $this->userurldecode);
	$t->set_var('TXT_RES', $result);
	$t->set_var('TXT_ONLINE_TIME', STR_HS_ONLINE_TIME);
	$t->set_var('TXT_REMAIN_TIME', STR_HS_REMAIN_TIME);
	$t->set_var('PAGE_TITLE', $this->message);
	$t->set_var('APP_CHARSET', $this->config['CHARSET']);
	$t->set_var('APP_LANGUAGE', $GLOBALS['LANGUAGE']);
	$t->set_var('APP_BBAR', $this->print_bbar());
	if (empty($this->a['embed_page'])) {
	    if (!empty($this->logo)) {
		if (!empty($this->uamserver))
		    $t->set_var('HOTSPOT_MAIN_SITE', $this->uamserver);
		else
		    $t->set_var('HOTSPOT_MAIN_SITE', '');
		$t->set_var('HOTSPOT_LOGO', $this->logo);
		$t->parse('hLogo', 'logo');
	    }
	}
	$t->pparse('out', 'hForm');
	$GLOBALS['HEADER_GENERATED'] = 1;
    }

    private function draw_logout($msg='') {
	$t = $this->load_template_resource(array('hForm'=>$this->subpath.'logform'));
	$t->set_var('LS_PATH', $this->get_ls_path());
	$t->set_var('TXT_MESSAGE', $msg);
	$t->set_var('TXT_TITLE', $this->message);
	$t->set_var('TXT_IMAGE', "btn-error");
	$t->set_var('TXT_ACTION', STR_APP_LOGOUT);
	$t->set_var('HIDDEN_VAR', '');
	$t->set_var('VAL_FORMACTION', 'http://'.$this->uamip.':'.$this->uamport.'/logoff');
	$t->pparse('out', 'hForm');
    }

    private function draw_login($msg='') {
	$t = $this->load_template_resource(array('hForm'=>$this->subpath.'logform'));
	$t->set_var('LS_PATH', $this->get_ls_path());
	$t->set_var('TXT_MESSAGE', $msg);
	$t->set_var('TXT_TITLE', $this->message);
	$t->set_var('TXT_IMAGE', "btn-success");
	$t->set_var('TXT_ACTION', STR_HS_PRESET_LOGIN);
	$t->set_var('HIDDEN_VAR', '');
	$t->set_var('VAL_FORMACTION', 'http://'.$this->uamip.':'.$this->uamport.'/prelogin');
	$t->pparse('out', 'hForm');
    }
        
    public function exec() {
	if ( empty($GLOBALS['LANGUAGE'])) {
	    if ( isset( $this->config['cp']['lang']))
		$GLOBALS['LANGUAGE'] = $this->config['cp']['lang'];
	    else
		$GLOBALS['LANGUAGE'] = 'en';
	}
	$this->load_string_resource('hotspot');
	$this->load_string_resource('cmmn');
	$this->load_string_resource('ssxapp');
	if ( !$this->do_login()) {
	    $result = 0;
	    switch($this->res) {
		case 'success':     $result =  1; break; // If login successful
		case 'failed':      $result =  2; break; // If login failed
		case 'logoff':      $result =  3; break; // If logout successful
		case 'already':     $result =  4; break; // If tried to login while already logged in
		case 'notyet':      $result =  5; break; // If not logged in yet
		case 'smartclient': $result =  6; break; // If login from smart client
		case 'popup1':      $result = 11; break; // If requested a logging in pop up window
		case 'popup2':      $result = 12; break; // If requested a success pop up window
		case 'popup3':      $result = 13; break; // If requested a logout pop up window
		default: $result = 0; // Default: It was not a form request
	    }
	    if ( $result == 0) {
		$this->do_error();
	    } else {
		$msg = '';
		if ($result == 2) {
		    $msg = STR_HS_FAILED;
		    if ($reply)
			$msg .= '&nbsp;:&nbsp;'.$reply;
		}
		if ($result == 1 || $result == 4 || $result == 12) {
		    $msg = STR_APP_VALID_LOGIN;
		    if ($reply)
			$msg .= '&nbsp;:&nbsp;'.$reply;
		    $this->draw_logout($msg);
		}
		if ($result == 11) {
		    $msg = STR_HS_LOGGING;
		}
		if ($result == 3 || $result == 13) {
		    $msg = STR_HS_LOGOUT;
		    $this->draw_login($msg);
		}
		if ($result == 2 || $result == 5)
		    $this->draw_login_form($msg);
		$this->draw_header( $result);
		$this->draw_body();
	    }
	}
	$this->render();
    }
}

$app = new hotspot;
$app->exec();

?>

