<?php
 class CompaniesDB extends ADO { var $className = 'Companies'; public function __construct( $app, $dburi, $debug=false, $tmode=true, $dformat='') { $this->owner = $app; if ( !empty($dburi)) $this->dburi = $dburi; return parent::__construct( $this->dburi, $debug, $tmode, $dformat); } public function get_records($lines_per_page, $page=0, $orgname='', $taxnum='', $provider_id=0) { $from_clause = 'sk_objects'; $query_ext = ''; if ( $orgname != '') $query_ext .= " AND sk_objects.orgname LIKE %'".$orgname."'%"; if ( $taxnum != '') $query_ext .= " AND sk_objects.tax_num='".$taxnum."'"; if ( $provider_id != 0) { $from_clause .= ',sk_operators'; $query_ext .= " AND sk_objects.resp_person=sk_operators.person_id AND sk_operators.provider_id=".$provider_id; } $res = $this->GetAll("SELECT count(*) FROM $from_clause WHERE sk_objects.mode='C'".$query_ext); if ( $page >= 0) { $low = $page*$lines_per_page; $high = $lines_per_page; $allRecs = $this->GetAll("SELECT sk_objects.obj_id, sk_objects.orgname, sk_objects.tax_num, sk_objects.locality, sk_objects.street, sk_objects.extadd, sk_objects.work_phone, sk_objects.home_phone, sk_objects.cell_phone, sk_objects.active, sk_objects.level FROM $from_clause WHERE sk_objects.mode='C' ".$query_ext." ORDER BY sk_objects.orgname LIMIT ".$high." OFFSET ".$low); } else $allRecs = $this->GetAll("SELECT sk_objects.obj_id, sk_objects.orgname, sk_objects.tax_num, sk_objects.locality, sk_objects.street, sk_objects.extadd, sk_objects.work_phone, sk_objects.home_phone, sk_objects.cell_phone, sk_objects.active, sk_objects.level FROM $from_clause WHERE sk_objects.mode='C' ".$query_ext." ORDER BY sk_objects.orgname"); return array( $res[0][0], $allRecs); } public function insert_from_globals() { $query = " INSERT INTO sk_objects (mode,level,add_date,last_date,active,orgname,tax_num,pcode,url,
country,email,region,home_phone,locality,street,work_phone,
extadd,comment,resp_person) VALUES (". "'C','0','".$this->owner->now()."','".$this->owner->now()."','". $GLOBALS['active']."','". $GLOBALS['orgname']."','".$GLOBALS['taxnum']."','". $GLOBALS['pcode']."','".$GLOBALS['url']."','". $GLOBALS['country']."','".$GLOBALS['email']."','". $GLOBALS['region']."','".str_replace('+','',$GLOBALS['homephone'])."','". $GLOBALS['locality']."','". $GLOBALS['street']."','".str_replace('+','',$GLOBALS['wphone'])."','". $GLOBALS['extadd']."','". $GLOBALS['desc']."','". $GLOBALS['SSXID']."')"; $this->BeginTrans(); if ( $this->Execute( $query)) { $this->CommitTrans(); $this->owner->log(CMMN_INFO, $_SERVER['REMOTE_ADDR'], $_SERVER['PHP_SELF'], $GLOBALS['USER'], '', sprintf( STR_COMPANIES_ADDED, $GLOBALS['orgname'])); return true; } else { $this->RollbackTrans(); $this->owner->log(CMMN_ERROR, $_SERVER['REMOTE_ADDR'], $_SERVER['PHP_SELF'], $GLOBALS['USER'], '', sprintf( STR_COMPANIES_ADDED_ERR, $GLOBALS['orgname'])); } return false; } public function delete_from_globals() { if ( isset($GLOBALS['id'])) { $this->BeginTrans(); if ( $this->Execute("DELETE FROM sk_objects WHERE mode='C' AND obj_id='".$GLOBALS['id']."'")) { $this->CommitTrans(); $this->owner->log(CMMN_INFO, $_SERVER['REMOTE_ADDR'], $_SERVER['PHP_SELF'], $GLOBALS['USER'], '', sprintf( STR_COMPANIES_DELETED, $GLOBALS['id'])); return true; } else { $this->RollbackTrans(); $this->owner->log(CMMN_ERROR, $_SERVER['REMOTE_ADDR'], $_SERVER['PHP_SELF'], $GLOBALS['USER'], '', sprintf( STR_COMPANIES_DELETED_ERR, $GLOBALS['id'])); } } return false; } public function modify_from_globals() { $query = " UPDATE sk_objects SET 
last_date='".$this->owner->now()."',
active='".$GLOBALS['active']."',
orgname='".$GLOBALS['orgname']."',
tax_num='".$GLOBALS['taxnum']."',
pcode='".$GLOBALS['pcode']."',
url='".$GLOBALS['url']."',
country='".$GLOBALS['country']."',
email='".$GLOBALS['email']."',
region='".$GLOBALS['region']."',
home_phone='".str_replace('+','',$GLOBALS['homephone'])."',
locality='".$GLOBALS['locality']."',
street='".$GLOBALS['street']."',
work_phone='".str_replace('+','',$GLOBALS['wphone'])."',
extadd='".$GLOBALS['extadd']."',
comment='".$GLOBALS['desc']."',
resp_person='".$GLOBALS['SSXID']."'
				WHERE mode='C' AND obj_id='".$GLOBALS['id']."'"; $this->BeginTrans(); if ( $this->Execute( $query)) { $this->CommitTrans(); $this->owner->log(CMMN_INFO, $_SERVER['REMOTE_ADDR'], $_SERVER['PHP_SELF'], $GLOBALS['USER'], '', sprintf( STR_COMPANIES_EDITED, $GLOBALS['orgname'])); return true; } else { $this->RollbackTrans(); $this->owner->log(CMMN_ERROR, $_SERVER['REMOTE_ADDR'], $_SERVER['PHP_SELF'], $GLOBALS['USER'], '', sprintf( STR_COMPANIES_EDITED_ERR, $GLOBALS['orgname'])); } return false; } public function get_record( $obj) { if ( ($a = $this->GetAll(sprintf("SELECT * FROM sk_objects WHERE mode='C' AND obj_id='%s'", $obj)))) return $a[0]; else return array(); } } ?>
