<?php
 class PeopleDB extends ADO { var $className = 'People'; public function __construct( $app, $dburi, $debug=false, $tmode=true, $dformat='') { $this->owner = $app; if ( !empty($dburi)) $this->dburi = $dburi; return parent::__construct( $this->dburi, $debug, $tmode, $dformat); } public function get_records($lines_per_page, $page=0, $fn='', $ln='', $mn='', $taxnum='', $provider_id=0) { $from_clause = 'sk_objects'; $query_ext = ''; if ( $fn != '') $query_ext .= " AND sk_objects.fn LIKE %'".$fn."'%"; if ( $mn != '') $query_ext .= " AND sk_objects.mn LIKE %'".$mn."'%"; if ( $ln != '') $query_ext .= " AND sk_objects.ln LIKE %'".$ln."'%"; if ( $taxnum != '') $query_ext .= " AND sk_objects.tax_num='".$taxnum."'"; if ( $provider_id != 0) { $from_clause .= ',sk_operators'; $query_ext .= " AND sk_objects.resp_person=sk_operators.person_id and sk_operators.provider_id=".$provider_id; } $res = $this->GetAll("SELECT count(*) FROM $from_clause WHERE sk_objects.mode='P'".$query_ext); if ( $page >= 0) { $low = $page*$lines_per_page; $high = $lines_per_page; $allRecs = $this->GetAll("SELECT sk_objects.obj_id, sk_objects.nickname, sk_objects.fn, sk_objects.ln, sk_objects.locality, sk_objects.street, sk_objects.extadd, sk_objects.home_phone, sk_objects.work_phone, sk_objects.cell_phone, sk_objects.orgname, sk_objects.active, sk_objects.level FROM $from_clause WHERE sk_objects.mode='P' ".$query_ext." ORDER BY sk_objects.fn LIMIT ".$high." OFFSET ".$low); } else $allRecs = $this->GetAll("SELECT sk_objects.obj_id, sk_objects.nickname, sk_objects.fn, sk_objects.ln, sk_objects.locality, sk_objects.street, sk_objects.extadd, sk_objects.home_phone, sk_objects.work_phone, sk_objects.cell_phone, sk_objects.orgname, sk_objects.active, sk_objects.level FROM $from_clause WHERE mode='P' ".$query_ext." ORDER BY fn"); return array($res[0][0], $allRecs); } public function insert_from_globals() { $query = " INSERT INTO sk_objects (mode,add_date,last_date,active,level,nickname,
role,fn,mn,ln,password,bday,orgname,orgunit,tax_num,ss_num,pcode,url,
country,email,region,home_phone,locality,cell_phone,street,work_phone,
extadd,exten,comment,resp_person) VALUES (". "'P','".$this->owner->now()."','".$this->owner->now()."','". $GLOBALS['active']."','". $GLOBALS['security']."','". $GLOBALS['short']."','". $GLOBALS['role']."','".$GLOBALS['firstname']."','". $GLOBALS['middlename']."','".$GLOBALS['lastname']."','". $GLOBALS['pwd']."','".$GLOBALS['birthdate']."','". $GLOBALS['orgname']."','".$GLOBALS['orgunit']."','". $GLOBALS['taxnum']."','".$GLOBALS['ssnum']."','". $GLOBALS['pcode']."','".(isset($GLOBALS['url'])?$GLOBALS['url']:'')."','". $GLOBALS['country']."','".$GLOBALS['email']."','". $GLOBALS['region']."','".str_replace('+','',$GLOBALS['homephone'])."','". $GLOBALS['locality']."','".str_replace('+','',$GLOBALS['cellphone'])."','". $GLOBALS['street']."','".str_replace('+','',$GLOBALS['wphone'])."','". $GLOBALS['extadd']."','".$GLOBALS['exten']."','". $GLOBALS['desc']."','".$GLOBALS['SSXID']."')"; $this->BeginTrans(); if ( $this->Execute( $query)) { $this->CommitTrans(); $this->owner->log(CMMN_INFO, $_SERVER['REMOTE_ADDR'], $_SERVER['PHP_SELF'], $GLOBALS['USER'], '', sprintf( STR_PEOPLE_ADDED, $GLOBALS['firstname'])); return true; } else { $this->RollbackTrans(); $this->owner->log(CMMN_ERROR, $_SERVER['REMOTE_ADDR'], $_SERVER['PHP_SELF'], $GLOBALS['USER'], '', sprintf( STR_PEOPLE_ADDED_ERR, $GLOBALS['firstname'])); } return false; } public function delete_from_globals() { if ( isset($GLOBALS['id'])) { $this->BeginTrans(); if ( $this->Execute("DELETE FROM sk_objects WHERE mode='P' AND obj_id='".$GLOBALS['id']."'")) { $this->CommitTrans(); $this->owner->log(CMMN_INFO, $_SERVER['REMOTE_ADDR'], $_SERVER['PHP_SELF'], $GLOBALS['USER'], '', sprintf( STR_PEOPLE_DELETED, $GLOBALS['id'])); return true; } else { $this->RollbackTrans(); $this->owner->log(CMMN_ERROR, $_SERVER['REMOTE_ADDR'], $_SERVER['PHP_SELF'], $GLOBALS['USER'], '', sprintf( STR_PEOPLE_DELETED_ERR, $GLOBALS['id'])); } } return false; } public function modify_from_globals() { $res = $this->GetAll("SELECT person_id FROM sk_operators WHERE person_id='".$GLOBALS['id']."'"); $have_operator = false; if (!empty($res[0][0])) { $res = $this->GetAll("SELECT nickname, password FROM sk_objects WHERE mode='P' AND obj_id='".$GLOBALS['id']."'"); $have_operator = (($res[0][0] !== $GLOBALS['short']) || ($res[0][1] !== $GLOBALS['pwd'])); } $query = " UPDATE sk_objects SET 
last_date='".$this->owner->now()."',
active='".$GLOBALS['active']."',
level='".$GLOBALS['security']."',
nickname='".$GLOBALS['short']."',
role='".$GLOBALS['role']."',
fn='".$GLOBALS['firstname']."',
mn='".$GLOBALS['middlename']."',
ln='".$GLOBALS['lastname']."',
password='".$GLOBALS['pwd']."',
bday='".$GLOBALS['birthdate']."',
orgname='".$GLOBALS['orgname']."',
orgunit='".$GLOBALS['orgunit']."',
tax_num='".$GLOBALS['taxnum']."',
ss_num='".$GLOBALS['ssnum']."',
pcode='".$GLOBALS['pcode']."',
country='".$GLOBALS['country']."',
email='".$GLOBALS['email']."',
region='".$GLOBALS['region']."',
home_phone='".str_replace('+','',$GLOBALS['homephone'])."',
locality='".$GLOBALS['locality']."',
cell_phone='".str_replace('+','',$GLOBALS['cellphone'])."',
street='".$GLOBALS['street']."',
work_phone='".str_replace('+','',$GLOBALS['wphone'])."',
extadd='".$GLOBALS['extadd']."',
exten='".$GLOBALS['exten']."',
comment='".$GLOBALS['desc']."',
resp_person='".$GLOBALS['SSXID']."'
				WHERE mode='P' AND obj_id='".$GLOBALS['id']."'"; $this->BeginTrans(); if ( $this->Execute( $query)) { $this->CommitTrans(); $this->owner->log(CMMN_INFO, $_SERVER['REMOTE_ADDR'], $_SERVER['PHP_SELF'], $GLOBALS['USER'], '', sprintf( STR_PEOPLE_EDITED, $GLOBALS['firstname'])); if ($have_operator) { lpd_library('user-lib.inc'); if ($res[0][0] === $GLOBALS['short']) { user_changepw($GLOBALS['short'], $GLOBALS['pwd']); user_changepw(sha1($GLOBALS['short']), sha1($GLOBALS['pwd'])); } else { if (is_array($res) && isset($res[0][0])) { mwexec('/opt/stasoft/bin/revokecrt.sh', 'openvpn people-'.$res[0][0]); if ( !empty($res[0][0])) { user_del(sha1($res[0][0])); user_del($res[0][0]); rename('/home/pool/'.$res[0][0], '/home/pool/'.$GLOBALS['short']); } } user_add($GLOBALS['short'], $GLOBALS['pwd'], '', '/home/pool/'.$GLOBALS['short'], '/bin/false'); user_add(sha1($GLOBALS['short']), sha1($GLOBALS['pwd']), '', sha1('/home/pool/'.$GLOBALS['short']), '/bin/false'); if (!file_exists('/etc/cert/authority/openvpn/issued/people-'.$GLOBALS['short'].'.crt')) { mwexec('/opt/stasoft/bin/mkclientcert.sh', 'openvpn people-'.$GLOBALS['short']); } copy('/etc/cert/authority/openvpn/issued/people-'.$GLOBALS['short'].'.crt', '/home/pool/'.$GLOBALS['short'].'/keys/people-'.$GLOBALS['short'].'.crt'); mwexec('chown', '-R '.$GLOBALS['short'].':'.$GLOBALS['short'].' /home/pool/'.$GLOBALS['short']); } } return true; } else { $this->RollbackTrans(); $this->owner->log(CMMN_ERROR, $_SERVER['REMOTE_ADDR'], $_SERVER['PHP_SELF'], $GLOBALS['USER'], '', sprintf( STR_PEOPLE_EDITED_ERR, $GLOBALS['firstname'])); } return false; } public function get_record( $obj) { if ( ($a = $this->GetAll(sprintf("SELECT * FROM sk_objects WHERE mode='P' AND obj_id='%s'", $obj)))) return $a[0]; else return array(); } } ?>
